import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**************************************************
 * 2014-2015 ICS4U Calculus Project *
 **************************************************/
public class Calculus {

	static String[] list = { "2X^2-3x+1", "xsin(x)", "x^2ln(3x)",
			"(2x-1)(1-4x^2)", "x^(3E)", "-1.5abs(2x)", "4sqrt(5-3.1x)",
			"(3x^4-4x^3)/(2-cos(1/(2x)))", "tan(2x)/3x", "e^atan(px)", "3ePE" };
//	static String filename = "TestHarness.txt";
	static String filename = "RootHarness.txt";
	static String entry;
	static String comment = "";
	static int commentPos;

	public static void main(String[] args) throws FileNotFoundException {
		File file = new File(filename);
		Scanner input = new Scanner(file);
		while (input.hasNext()) {
			entry = input.nextLine();
			commentPos = entry.indexOf(";");
			
			if (commentPos>-1){
				System.out.println(entry.substring(commentPos));
				entry = entry.substring(0,commentPos).trim();
			}
			if (entry.length() > 0) {
				String[] details = entry.split(",");
				String def = details[0];
				double x = Double.parseDouble(details[1]);
				double a = Double.parseDouble(details[2]);
				double b = Double.parseDouble(details[3]);
				double step = Double.parseDouble(details[4]);

				Function f = new Function(def,a,b,step);
				String parsing = String.format("PARS: f(x) = %-17s", def);

				// Attempt to parse the input...
				System.out.printf("%-30s", parsing);
				System.out.printf("RESULT: %-25s", f.getErrorMessage());
				if (f.getErrorCode() == 0)
					System.out.printf("TREE: %-25s", f.reportStructure(0));
				System.out.println();

				// If parsed without issue, attempt to evaluate...
				if (f.getErrorCode() == 0) {
					String domain = String.format("%-6.2f", x).trim();
					String evaluation = String.format("EVAL: f(%s)  = %-20.5f",
							domain, f.f(0, x));
					System.out.printf("%-30s", evaluation.trim());
					System.out.printf("RESULT: %-25s", f.getErrorMessage());
					System.out.printf("TREE: %s\n", f.reportStructure(0));

					evaluation = String.format("EVAL: f'(%s) = %-20.5f", domain,
							f.f(1, x));
					System.out.printf("%-30s", evaluation.trim());
					System.out.printf("RESULT: %-25s", f.getErrorMessage());
					System.out.printf("TREE: %s\n", f.reportStructure(1));
					evaluation = String.format("EVAL: f''(%s)= %-20.5f", domain,
							f.f(2, x));
					System.out.printf("%-30s", evaluation.trim());
					System.out.printf("RESULT: %-25s", f.getErrorMessage());
					System.out.printf("TREE: %s\n", f.reportStructure(2));
				}
				System.out.println(">Summary of Roots:");
				System.out.println("  f:"+f.getRoots(0));
				System.out.println(" f':"+f.getRoots(1));
				System.out.println("f'':"+f.getRoots(2));
				System.out.printf(">Analysis over the closed interval [%5.2f,%5.2f]:\n",a,b);
				System.out.println(f.getAnalysis());
				System.out.println("----------------End of Analysis---------------------------------");
				System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
				
			}
		}
	}
}
